package fr.username404.snowygui.exec

import java.awt.*
import javax.swing.*

private val Background: Color = Color(
    32, // Red
    32, // Green
    135, // Blue
    120
)

object ExecObj {
    fun createWindow() {
        val frame = JFrame("Snowy Info")
        with(frame) {
            createInterface(this)
            setSize(300, 410)
            isResizable = false
            defaultCloseOperation = JFrame.EXIT_ON_CLOSE
            isVisible = true
        }
    }
    private fun createInterface(frame: JFrame) {
        frame.setLocationRelativeTo(null)
        val panel: JPanel = object: JPanel() {
            override fun paintComponent(g: Graphics?) {
                if (g is Graphics2D) {
                    val p: Paint = GradientPaint(
                        0.0f,
                        0.0f,
                        Background,
                        width.toFloat(),
                        height.toFloat(),
                        Color(
                            52,
                            170,
                            166,
                            255
                        ),
                        true
                    )
                    g.paint = p
                    g.fillRect(0, 0, width, height)
                } else {
                    super.paintComponent(g)
                }
            }; init {
                layout = FlowLayout()
                componentOrientation = ComponentOrientation.LEFT_TO_RIGHT
                ((this.layout) as FlowLayout).alignment = FlowLayout.CENTER
            }
        }.apply {
            // TODO Add text
            add(
                JLabel(
                    ImageIcon(
                        Toolkit.getDefaultToolkit()
                            .createImage(ExecObj.javaClass.getResourceAsStream("/icon.png")?.readAllBytes())
                            .getScaledInstance(256, 256, Image.SCALE_SMOOTH)
                    )
                )
            )
            add(
                JLabel("<html>You should install this mod by dropping it into your mods folder, and not by running it.</html>").apply {
                    font = Font.createFont(Font.TRUETYPE_FONT, ExecObj.javaClass.getResourceAsStream("/font/NotoSans-Regular.ttf")).deriveFont(Font.BOLD, 20F)
                    verticalTextPosition = SwingConstants.CENTER
                    horizontalTextPosition = SwingConstants.CENTER
                    preferredSize = Dimension(
                        290, 110
                    )
                }
            )
        }
        frame.contentPane = panel
    }
}

fun main() {
    ExecObj.createWindow()
}